#include <stdio.h>
#include <math.h>


int
main(){
	double x,y;
	scanf("%lf %lf", &x, &y);

	double rez = ( 1+sin(x+y)*sin(x+y) )/
	 ( 2 + fabs(x - (2*x*x)/(1+fabs(sin(x+y)))));

	printf("%lf\n", rez);
return 0;}

